# -*- coding: utf-8 -*-
import logging, mv_common
import os, re

def setup_software(systemconfig, data_config):
    if  mv_common.read_config(mv_common.module_config,"software")  == False  :
        logging.info("____Skipping of software, config disabled____")
        return

    logging.info("____Start of Software install____")
    postfix=''
    if data_config.SYSTEMTYPE == "MythVantage":
      #look for the installed prefix
      cmd="pacman -Q mythtv-release-fixes"
      rc = mv_common.runcmd(cmd)
      if rc == 0:
        postfix = "-release-fixes"
      else:
        postfix = "-svn"
#This section is for MythVantage OS, not LINHES
      default_disabled = ("mytharchive", "mythbrowser", "mythnews",
                          "mythgame",  "mythweather", "mythzoneminder","mythnetvision" )

      default_installed=("mythgallery", "mythmusic", "mythsmolt", "mythvideo")
      other_pkg=("miro", "mednafen", "romdb", "xine", "dvdcss", "webmin" , "fuppes", "foldingathome", "mythappletrailers", "mythstream", "mupen64")
    else:
      default_disabled = ("mytharchive", "mythbrowser", "mythnews",
                          "mythgame", "mythweather",
                          "mythappletrailers", "mythstream",  "mythzoneminder","mythnetvision" )

      default_installed=("mythgallery", "mythmovies", "mythmusic", "mythsmolt", "mythvideo")
      other_pkg=("miro", "mednafen", "romdb", "xine", "dvdcss", "webmin" , "fuppes", "foldingathome","mupen64")

    for pkg in default_disabled:
        pkgname=pkg+postfix
        try:
            if systemconfig[pkg] == "1":
                mv_common.pacinstall(pkgname)
            else:
                mv_common.pacremove(pkgname)
        except:
            logging.debug("  ERROR-- %s is not defined", pkg)

    for pkg in default_installed:
        pkgname=pkg+postfix
        try:
            if systemconfig[pkg] == "0":
                mv_common.pacremove(pkgname)
            else:
                mv_common.pacinstall(pkgname)
        except:
            logging.debug("  ERROR-- %s is not defined", pkg)

    for pkg in other_pkg:
        try:
            if systemconfig[pkg] == "1":
                mv_common.pacinstall(pkg)
            elif systemconfig[pkg] == "0":
                mv_common.pacremove(pkg)
        except:
            logging.debug("   ERROR-- %s is not defined", pkg)
    logging.info("__End Software\n ")
